IMPLEMENTATION MODULE Enemigos;
IMPORT Lib,Game,Pantalla,Variable;
FROM Storage IMPORT ALLOCATE,DEALLOCATE;
TYPE
	PT_Enemigo= POINTER TO T_Enemigo;
	T_Enemigo= RECORD
			x:CARDINAL ;
			y:CARDINAL ;
			n_disparos:CARDINAL ;
			sig_enemigo:PT_Enemigo;
		   END;

	ENEMIGO=POINTER TO T_Enemigo;
	
(*CONST
	Ancho_Pantalla=500;
	Alto_Pantalla=10;*)

PROCEDURE InicializarEnemigo(VAR Enemigo:ENEMIGO);
BEGIN
        NEW(Enemigo);
	Enemigo^.n_disparos:=0;
	Enemigo^.sig_enemigo:=NIL;
END InicializarEnemigo;

PROCEDURE Destruir(VAR Enemigo:ENEMIGO);
VAR
	pt,pt2:PT_Enemigo;
BEGIN
	pt:=Enemigo^.sig_enemigo;
	DISPOSE (Enemigo);
	WHILE pt#NIL  DO
		pt2:=pt;
		pt:=pt^.sig_enemigo;
		DISPOSE (pt2);
	END;
END Destruir;


PROCEDURE CrearyColocarEnemigosAleatorio(VAR Enemigo:ENEMIGO;VAR P:Pantalla.PANTALLA;N_Enemigos:CARDINAL;V:Variable.VARIABLES);
VAR
	i,x,y:CARDINAL ;
	enemigo:PT_Enemigo;
BEGIN
	Lib.RANDOMIZE;
	FOR i:=1 TO N_Enemigos DO
		NEW (enemigo);
		enemigo^.n_disparos:=0;
		enemigo^.sig_enemigo:=Enemigo^.sig_enemigo;
		Enemigo^.sig_enemigo:=enemigo;
                x:=(Lib.RANDOM(Variable.Ancho_Pantalla(V)-20)+20);
                y:=Lib.RANDOM(Variable.Alto_Pantalla(V));
                WHILE Pantalla.Ocupado(x,y,P,'c') DO;
                      x:=(Lib.RANDOM(Variable.Ancho_Pantalla(V)-20)+20);
                      y:=Lib.RANDOM(Variable.Alto_Pantalla(V));
                END;
                enemigo^.x:=x;
                enemigo^.y:=y;
                Pantalla.ColocarEnemigo(x,y,P);
	END;
END CrearyColocarEnemigosAleatorio;

PROCEDURE Actualizar(VAR Enemigo:ENEMIGO;VAR P:Pantalla.PANTALLA;V:Variable.VARIABLES):BOOLEAN ;
VAR
        NaveMuerta,NaveMuertatmp:BOOLEAN;
        enemigo:PT_Enemigo;
        mov:CARDINAL;
        ocupacion:CHAR ;
BEGIN
        Lib.RANDOMIZE;
        NaveMuerta:=FALSE ;
        enemigo:=Enemigo^.sig_enemigo;
        WHILE enemigo#NIL DO
            Pantalla.ColocarNada(enemigo^.x,enemigo^.y,P);
            mov:=Lib.RANDOM(4);
            CASE mov OF
                 0:(*Movimiento de enmigo arriba si puede*)
                 IF enemigo^.y>0 THEN
                    ocupacion:=Pantalla.Obtener(enemigo^.x,enemigo^.y-1,P);
                    CASE ocupacion OF
                      '4': NaveMuertatmp:=TRUE
                      |
                      '0': DEC (enemigo^.y);
                    END;
                 END;
                 |
                 1:(*Movimiento de enemigo abajo si puede*)
                 IF enemigo^.y<Variable.Alto_Pantalla(V)-1 THEN
                    ocupacion:=Pantalla.Obtener(enemigo^.x,enemigo^.y+1,P);
                    CASE ocupacion OF
                      '4': NaveMuertatmp:=TRUE
                      |
                      '0': INC (enemigo^.y);
                    END;
                 END ;
            END;
            Pantalla.ColocarEnemigo(enemigo^.x,enemigo^.y,P);
            enemigo:=enemigo^.sig_enemigo;
        END;
        RETURN NaveMuerta;
END Actualizar;

PROCEDURE Eliminar(VAR E:ENEMIGO;x,y:CARDINAL);
VAR
  enemigo,enemigoelim:PT_Enemigo;
BEGIN
	
	IF ((E^.sig_enemigo#NIL) AND (E^.sig_enemigo^.x=x) AND (E^.sig_enemigo^.y=y)) THEN
		enemigoelim:=E^.sig_enemigo;
		E^.sig_enemigo:=E^.sig_enemigo^.sig_enemigo;
		DISPOSE (enemigoelim);
	ELSE
		enemigo:=E^.sig_enemigo;
		WHILE ((enemigo#NIL) AND (enemigo^.sig_enemigo#NIL)) DO
			IF ((enemigo^.sig_enemigo^.x=x) AND (enemigo^.sig_enemigo^.y=y)) THEN
				enemigoelim:=enemigo^.sig_enemigo;
				enemigo^.sig_enemigo:=enemigo^.sig_enemigo^.sig_enemigo;
				DISPOSE (enemigoelim);
			ELSE
				enemigo:=enemigo^.sig_enemigo;
			END;
		END;
	END;
	
END Eliminar;

END Enemigos.