IMPLEMENTATION MODULE Game;
FROM Storage IMPORT ALLOCATE,DEALLOCATE;
IMPORT Pantalla,Nave,Disparos,Lib,IO,Enemigos,Variable;
TYPE
   Cadena=ARRAY [0..12]OF CHAR;
(*CONST
	Ancho_Pantalla=500;
	Alto_Pantalla=10;
	velocidad=1;
	numero_actualizaciones_disparos=3;
	numero_enemigos=50;*)
	

PROCEDURE TerminarJuego(VAR N:Nave.NAVE;VAR D:Disparos.DISPARO;VAR E:Enemigos.ENEMIGO;VAR P:Pantalla.PANTALLA);
BEGIN
	Nave.Destruir(N);
	Disparos.Destruir(D);
	Enemigos.Destruir(E);
	Pantalla.Destruir(P);
	
END TerminarJuego;




PROCEDURE Juego(tipo:CARDINAL;V:Variable.VARIABLES);
(*CONST
    Archivo_Pantalla='fase1.dat';*)
VAR
	P:Pantalla.PANTALLA;
	N:Nave.NAVE;
	D:Disparos.DISPARO;
	E:Enemigos.ENEMIGO;
	NaveMuerta,NaveMatada,salir,fin_pantalla,dispara:BOOLEAN;
	key:CHAR;
	FILE:Cadena;
	i,x,y:CARDINAL ;
        Activado_Sonido:BOOLEAN;	
BEGIN
        Activado_Sonido:=tipo=1;
	   (*Inicializan Pantalla, nave,disparos ya q no cambian con el nivel*)
        Variable.Archivo_Pantalla(V,FILE);	
	Pantalla.CrearPantalla (P,FILE,V);
	Nave.CrearNave(N);
	Disparos.InicializarDisparo(D);
	   (*Coloca la nave en la pantalla por primera vez*)
	Pantalla.ColocarNave(Nave.ObtenerCoordenadaX(N),Nave.ObtenerCoordenadaY(N),P);
(*En el otro dice mostrar marcadores, vidas y tal ademas de pantalla y nave*)
	   (*Mostrar pantalla*)
	Pantalla.MostrarPantalla(P,V);
	   (*Inicializa variables de salida del juego*)
	NaveMuerta:=FALSE;NaveMatada:=FALSE;salir:=FALSE;dispara:=FALSE ;
	   (*Segun el tipo de juego hace unas cosas o otras*)
	   (*Inicializar los enemigos y colocarlos falta*)
	Enemigos.InicializarEnemigo(E);
	Enemigos.CrearyColocarEnemigosAleatorio(E,P,Variable.numero_enemigos(V),V);
		REPEAT
		   (*Si se pulsa una tecla hacer*)
		IF IO.KeyPressed() THEN
			key:=CAP(IO.RdKey());
(**)			   (*Si la tecla es escape salir(preguntar antes) sino seguir el juego*)
			IF key=CHR(27) THEN
				salir:=TRUE;
			ELSE ;
				  (*Borra la posicion anterior de la nave*)
				Pantalla.ColocarNada(Nave.ObtenerCoordenadaX(N),Nave.ObtenerCoordenadaY(N),P);			
				dispara:= Nave.AccionNave(N,P,key,V);
				  (*Si la accion es un disparo,crea disparo,lo pone en pantalla y lo muestra*)
				IF dispara THEN
                                        IF Activado_Sonido THEN Lib.Sound(2500) END;
					Disparos.CrearDisparo(D,(Nave.ObtenerCoordenadaX(N)+1),Nave.ObtenerCoordenadaY(N),'D');
					Disparos.ObtenerCoordenadasXY(D,x,y,1);
					Pantalla.ColocarDisparo(x,y,P);
					IF Disparos.ObtenerNumeroDisparos(D)>0 THEN
						NaveMatada:=Disparos.Actualizar(N,D,P,E);
					END ;
					IF NaveMatada THEN
						NaveMuerta:=TRUE ;
					END;
				        dispara:=FALSE ;
                                        IF Activado_Sonido THEN Lib.Sound(5000) END;
				END;
				NaveMuerta:=Pantalla.Ocupado(Nave.ObtenerCoordenadaX(N),Nave.ObtenerCoordenadaY(N),P,'c');
				IF NOT NaveMuerta THEN
					Pantalla.ColocarNave(Nave.ObtenerCoordenadaX(N),Nave.ObtenerCoordenadaY(N),P);			
				END;
			END ;
		END;
		(*movimiento automatico de enemigo*)
		NaveMatada:=Enemigos.Actualizar(E,P,V);
		IF NaveMatada THEN
			NaveMuerta:=TRUE ;
		END;
		
		(*movimiento automatico de disparo*)
		IF Disparos.ObtenerNumeroDisparos(D)>0 THEN
			FOR i:=1 TO Variable.numero_actualizaciones_disparos(V) DO
				NaveMatada:=Disparos.Actualizar(N,D,P,E);
				IF NaveMatada THEN
					NaveMuerta:=TRUE ;
				END;
				Pantalla.MostrarPantalla(P,V);
			END;
		END ;
		(*incrementar movimiento nave al moverse pantalla*)
		Pantalla.ColocarNada(Nave.ObtenerCoordenadaX(N),Nave.ObtenerCoordenadaY(N),P);
		dispara:=Nave.AccionNave(N,P,'D',V);
		NaveMuerta:=Pantalla.Ocupado(Nave.ObtenerCoordenadaX(N),Nave.ObtenerCoordenadaY(N),P,'C');
		IF NOT NaveMuerta THEN
			Pantalla.ColocarNave(Nave.ObtenerCoordenadaX(N),Nave.ObtenerCoordenadaY(N),P);			
			(*incrementar movimiento de la pantalla*)
			fin_pantalla:=Pantalla.IncrementarPantalla(P,V);
			Pantalla.MostrarPantalla(P,V);
		END;
                (*Velocidad del juego*)
		Lib.Delay (Variable.velocidad(V)*50);
		Lib.NoSound;
		UNTIL NaveMatada OR NaveMuerta OR salir OR fin_pantalla;
                IF fin_pantalla THEN
                        Pantalla.MostrarFinJuego(V);
                ELSE
                        Pantalla.MostrarGameOver(V);
                END;
                TerminarJuego(N,D,E,P);
END Juego;



END Game.