IMPLEMENTATION MODULE Nave;
IMPORT Game,Pantalla,IO,Variable;
FROM Storage IMPORT ALLOCATE,DEALLOCATE;
(*CONST
	max_disparos=2;*)
TYPE

	T_Nave= RECORD
			x:CARDINAL ;
			y:CARDINAL ;
			n_disparos:CARDINAL;
		END;
	NAVE=POINTER TO T_Nave;

PROCEDURE CrearNave(VAR Nave:NAVE);
   BEGIN
	NEW (Nave);
	Nave^.x:=1;
	Nave^.y:=5;
	Nave^.n_disparos:=0;
END CrearNave;

PROCEDURE Destruir(VAR Nave:NAVE);
BEGIN
	DISPOSE (Nave);
	
END Destruir;

PROCEDURE ObtenerNumeroDisparos(Nave:NAVE):CARDINAL;
BEGIN
    RETURN Nave^.n_disparos;
END ObtenerNumeroDisparos;

PROCEDURE ObtenerCoordenadaX(Nave:NAVE):CARDINAL;
BEGIN
    RETURN Nave^.x;
END ObtenerCoordenadaX;

PROCEDURE ObtenerCoordenadaY(Nave:NAVE):CARDINAL;
BEGIN
    RETURN Nave^.y;
END ObtenerCoordenadaY;

PROCEDURE DecrementaNumeroDisparos(VAR Nave:NAVE);
BEGIN
	DEC(Nave^.n_disparos);
END DecrementaNumeroDisparos;


PROCEDURE AccionNave(VAR Nave:NAVE;P:Pantalla.PANTALLA;key:CHAR;V:Variable.VARIABLES):BOOLEAN ;
VAR
	dispara:BOOLEAN ;
BEGIN
	dispara:=FALSE ;
	CASE ORD(key) OF
	(*mover a la derecha*)
	68:
		IF NOT Pantalla.Se_Sale(Nave^.x+1,Nave^.y,P) THEN
		INC(Nave^.x);
		END;
	|
	(*mover a la izquierda*)
	65 :
		IF ((NOT Pantalla.Se_Sale(Nave^.x,Nave^.y,P))AND (Nave^.x#0)) THEN
		DEC(Nave^.x);
		END;
	|
	(*mover a la arriba*)
	87 :
		IF ((NOT Pantalla.Se_Sale(Nave^.x,Nave^.y,P))AND (Nave^.y#0)) THEN
		DEC(Nave^.y);
		END;
	|
	(*mover a la abajo*)
	83 :
		IF NOT Pantalla.Se_Sale(Nave^.x,Nave^.y+1,P) THEN
		INC(Nave^.y);
		END ;
	|
	(*mover a la abajo*)
	ORD(' '):
		IF Nave^.n_disparos<Variable.max_disparos(V) THEN
			INC(Nave^.n_disparos);
			(*Aadir disparo a la lista de disparos D,condireccion derecha*)
			dispara:=TRUE ;
			
		END;
	END;
	RETURN dispara;
END AccionNave;

END Nave.