IMPLEMENTATION MODULE Variable;
FROM Storage IMPORT ALLOCATE,DEALLOCATE ;
IMPORT Str,IO;
TYPE
	PT_variables=POINTER TO T_variables;
	
	T_variables=RECORD
			Archivo_Presentacion:ARRAY [0..12] OF CHAR;
			Archivo_Menu:ARRAY [0..12] OF CHAR ;
			Archivo_GameOver:ARRAY [0..12] OF CHAR ;
			Archivo_FinJuego:ARRAY [0..12] OF CHAR ;
			Archivo_Pantalla:ARRAY [0..12] OF CHAR;
			Ancho_Pantalla: CARDINAL ;
			Alto_Pantalla: CARDINAL ;
			max_disparos: CARDINAL;
			velocidad:CARDINAL ;
			numero_actualizaciones_disparos: CARDINAL ;
			numero_enemigos: CARDINAL ;

		    END;


	VARIABLES=PT_variables;
PROCEDURE InicializarVariables(VAR V:VARIABLES);
BEGIN
	NEW (V);
	V^.Archivo_Presentacion:='fase0.dat';
	V^.Archivo_Menu:='menu.dat';
	V^.Archivo_GameOver:='gameover.dat';
	V^.Archivo_FinJuego:='finjuego.dat';
	V^.Archivo_Pantalla:='fase1.dat';

	V^.Ancho_Pantalla:=500;
	V^.Alto_Pantalla:=10;
	V^.max_disparos:=2;
	V^.velocidad:=2;
	V^.numero_actualizaciones_disparos:=3;
	V^.numero_enemigos:=50;
END InicializarVariables;

PROCEDURE Archivo_Presentacion(V:VARIABLES;VAR FICH:ARRAY OF CHAR) ;
BEGIN
        Str.Copy(FICH,V^.Archivo_Presentacion);
END Archivo_Presentacion;

PROCEDURE Archivo_Menu(V:VARIABLES;VAR FICH:ARRAY OF CHAR );
BEGIN
	Str.Copy(FICH,V^.Archivo_Menu);
END Archivo_Menu;

PROCEDURE Archivo_GameOver(V:VARIABLES;VAR FICH:ARRAY OF CHAR) ;
BEGIN
	Str.Copy(FICH,V^.Archivo_GameOver);
END Archivo_GameOver;

PROCEDURE Archivo_FinJuego(V:VARIABLES;VAR FICH:ARRAY OF CHAR) ;
BEGIN
	Str.Copy(FICH, V^.Archivo_FinJuego);
END Archivo_FinJuego;
PROCEDURE Archivo_Pantalla(V:VARIABLES;VAR FICH:ARRAY OF CHAR);
BEGIN
	Str.Copy(FICH, V^.Archivo_Pantalla);
END Archivo_Pantalla;




PROCEDURE Ancho_Pantalla(V:VARIABLES):CARDINAL ;
BEGIN
	RETURN V^.Ancho_Pantalla;
END Ancho_Pantalla;

PROCEDURE Alto_Pantalla(V:VARIABLES):CARDINAL ;
BEGIN
	RETURN V^.Alto_Pantalla;
END Alto_Pantalla;

PROCEDURE max_disparos(V:VARIABLES):CARDINAL ;
BEGIN
	RETURN V^.max_disparos;
END max_disparos;

PROCEDURE velocidad(V:VARIABLES):CARDINAL ;
BEGIN
	RETURN V^.velocidad;
END velocidad;

PROCEDURE numero_actualizaciones_disparos(V:VARIABLES):CARDINAL ;
BEGIN
	RETURN V^.numero_actualizaciones_disparos;
END numero_actualizaciones_disparos;

PROCEDURE numero_enemigos(V:VARIABLES):CARDINAL ;
BEGIN
	RETURN V^.numero_enemigos;
END numero_enemigos;


PROCEDURE ActualizaArchivo_Presentacion(VAR V:VARIABLES;FICH:ARRAY OF CHAR );
BEGIN
	Str.Copy(V^.Archivo_Presentacion,FICH);
END ActualizaArchivo_Presentacion;

PROCEDURE ActualizaArchivo_Menu(VAR V:VARIABLES;FICH:ARRAY OF CHAR );
BEGIN
	Str.Copy(V^.Archivo_Menu,FICH);
END ActualizaArchivo_Menu;

PROCEDURE ActualizaArchivo_GameOver(VAR V:VARIABLES;FICH:ARRAY OF CHAR) ;
BEGIN
	Str.Copy(V^.Archivo_GameOver,FICH);
END ActualizaArchivo_GameOver;

PROCEDURE ActualizaArchivo_FinJuego(VAR V:VARIABLES;FICH:ARRAY OF CHAR) ;
BEGIN
	Str.Copy(V^.Archivo_FinJuego,FICH);
END ActualizaArchivo_FinJuego;

PROCEDURE ActualizaArchivo_Pantalla(VAR V:VARIABLES;FICH:ARRAY OF CHAR);
BEGIN
	Str.Copy(V^.Archivo_Pantalla,FICH);
END ActualizaArchivo_Pantalla;

PROCEDURE Actualizamax_disparos(VAR V:VARIABLES;Num:CARDINAL) ;
BEGIN
	V^.max_disparos:=Num;
END Actualizamax_disparos;

PROCEDURE Actualizavelocidad(VAR V:VARIABLES;Num:CARDINAL) ;
BEGIN
	V^.velocidad:=Num;
END Actualizavelocidad;

PROCEDURE Actualizanumero_enemigos(VAR V:VARIABLES;Num:CARDINAL) ;
BEGIN
	V^.numero_enemigos:=Num;
END Actualizanumero_enemigos;
		
	    

END Variable.